package com.chilunyc.fumao;

import com.chilunyc.fumao.common.config.ApplicationProperty;
import com.chilunyc.fumao.config.bean.MultiBeanNameGenerator;
import com.alibaba.fastjson.parser.ParserConfig;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.boot.system.ApplicationPidFileWriter;
import org.springframework.boot.web.servlet.ServletComponentScan;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.data.jpa.repository.config.EnableJpaAuditing;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.security.config.annotation.method.configuration.EnableGlobalMethodSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 *
 */
@SpringBootApplication()
@EnableAsync
@EnableScheduling
@EnableJpaRepositories
@EnableJpaAuditing
@EnableTransactionManagement
@EnableWebSecurity
@EnableGlobalMethodSecurity(
        prePostEnabled = true
)
@ServletComponentScan()
@EnableConfigurationProperties(ApplicationProperty.class)
public class Application {

    public static void main(String[] args) {
        //
        ParserConfig.getGlobalInstance().setAutoTypeSupport(true);

        //
        ConfigurableApplicationContext run = new SpringApplicationBuilder(Application.class)
                .addCommandLineProperties(false)
                .listeners(new ApplicationPidFileWriter("./app.pid"))
                .beanNameGenerator(new MultiBeanNameGenerator())
                .run(args);
    }
}
