package com.chilunyc.fumao.api.system;

import com.chilunyc.fumao.common.lbs.request.LBSPoiRequest;
import com.chilunyc.fumao.common.lbs.service.LBSService;
import com.chilunyc.fumao.common.response.JsonResponse;
import com.chilunyc.fumao.common.shiro.AuthRoles;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 *
 */
@Log4j
@Api(description = "登录登出")
@RestController
@RequestMapping("/system/lbs")
@PreAuthorize(AuthRoles.SystemAdminExp)
class LBSController {

    @Autowired
    LBSService lbsService;

    @ApiOperation(value = "登录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "request", required = true, paramType = "body", dataType = "LoginRequest")
    })
    @RequestMapping(value = "/poi/find", method = RequestMethod.POST)
    JsonResponse login(@RequestBody @Valid LBSPoiRequest request) {
        return JsonResponse.success(lbsService.findPoi(request));
    }
}