package com.chilunyc.fumao.config.web;

import com.chilunyc.fumao.config.web.security.SecurityFilter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;
import org.springframework.security.config.http.SessionCreationPolicy;
import org.springframework.security.web.authentication.UsernamePasswordAuthenticationFilter;

/**
 * Created by Tkk on 2018/7/23.
 */
@Configuration
public class WebSecurityConfig extends WebSecurityConfigurerAdapter {


    @Autowired
    SecurityFilter securityFilter;

    @Override
    protected void configure(HttpSecurity http) throws Exception {
        http
                // 开启跨域
                .cors()

                // 取消session
                .and().sessionManagement().sessionCreationPolicy(SessionCreationPolicy.NEVER)

                // 关闭csrf
                .and().csrf().disable()


                .authorizeRequests()

                // 放行登录
                .antMatchers(
                        "/login",
                        "/login/**",
                        "/**/login",
                        "/**/login/**")
                    .permitAll()

                // 放行通用
                .antMatchers(
                        "/common/**")
                    .permitAll()

                // 其他全部校验
                .anyRequest()
                    .authenticated()

                // 增加过滤器, 过滤权限
                .and()
                .addFilterBefore(securityFilter, UsernamePasswordAuthenticationFilter.class);

    }
}
