package com.chilunyc.fumao.controller.error;

import com.chilunyc.fumao.common.response.JsonResponse;
import com.alibaba.fastjson.JSON;
import lombok.extern.log4j.Log4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.web.ErrorAttributes;
import org.springframework.boot.autoconfigure.web.ErrorController;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 *
 */
@Log4j
@RestController
@RequestMapping("/error")
public class PanicController implements ErrorController {

    @Autowired
    ErrorAttributes errorAttributes;

    @Autowired
    ExceptionController exceptionController;

    @Override
    public String getErrorPath() {
        return "/error";
    }

    @RequestMapping
    public JsonResponse error(HttpServletRequest aRequest) throws Exception {
        RequestAttributes requestAttributes = new ServletRequestAttributes(aRequest);
        Map<String, Object> errorAttributes = this.errorAttributes.getErrorAttributes(requestAttributes, false);
        log.error(String.format("[%s] => [%s]", errorAttributes.get("path"), JSON.toJSONString(errorAttributes)));
        return errorAttributes.get("error") != null ? JsonResponse.fail(errorAttributes.get("error").toString()) : JsonResponse.fail();
    }

}
