package com.chilunyc.fumao.common.request;

import lombok.Data;

import java.util.Date;

/**
 *
 */
@Data
public class PageRequest {

    private int size;

    private int page;

    private Date[] timeRange;

    public Date getStartTime(){
        return timeRange != null && timeRange.length == 2 ? timeRange[0] : null;
    }

    public Date getEndTime(){
        return timeRange != null && timeRange.length == 2 ? timeRange[1] : null;
    }

    /**
     * @return
     */
    public int getStart() {
        return (page < 0 ? 0 : page) * getSize();
    }

    public int getPageI() {
        return page < 0 ? 0 : page;
    }

    public int getSize() {
        return size <= 0 || size > 100 ? 10 : size;
    }

    public org.springframework.data.domain.PageRequest getPage() {
        return new org.springframework.data.domain.PageRequest(getPageI(), getSize());
    }
}
