package com.chilunyc.fumao.common.sms.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import java.util.Date;

/**
 *
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "fumao_sms")
public class Sms {

    @Id
    @Column(columnDefinition = "bigint(64)")
    private String id;

    /**
     * 手机号
     */
    @Column(length = 11)
    private String mobile;

    /**
     * 发送类型
     */
    @Column(length = 16)
    @Enumerated(EnumType.STRING)
    private SmsType type;

    /**
     * 验证次数
     */
    @Column(length = 2)
    private Integer checkCount;

    /**
     * 内容
     */
    private String content;

    /**
     * 备注
     */
    private String mark;

    /**
     * 过期时间
     */
    private Date expiredTime;

    /**
     *
     */
    private Boolean isCheck;

    /**
     *
     */
    private Date createTime;
}
