package com.chilunyc.fumao.common.sms.request;

import com.chilunyc.fumao.common.sms.model.SmsType;
import com.chilunyc.fumao.common.util.jpa.query.QueryItem;
import com.chilunyc.fumao.common.util.jpa.query.QueryType;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.hibernate.validator.constraints.NotBlank;
import org.springframework.data.jpa.domain.Specification;

import javax.persistence.criteria.Predicate;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;

/**
 *
 */
@ApiModel
@Data
public class SmsCheckRequest {

    @ApiModelProperty(value = "手机号")
    @NotBlank(message = "请输入手机号")
    @Pattern(regexp = "1[\\d]{10}", message = "请输入正确的手机号")
    @QueryItem(type = QueryType.equal)
    private String mobile;

    @ApiModelProperty(value = "短信验证码")
    @NotBlank(message = "请输入短信验证码")
    private String code;

    @ApiModelProperty(hidden = true)
    @QueryItem(type = QueryType.equal)
    private SmsType type;

    @QueryItem(type = QueryType.equal)
    private boolean isCheck = false;
}
