package com.chilunyc.fumao.common.util;

import com.chilunyc.fumao.common.enums.Comparing;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.BoundValueOperations;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Component;

import java.util.concurrent.TimeUnit;

/**
 *
 */
@Component
public class CountHelper {

    @Autowired
    private StringRedisTemplate redisTemplate;

    /**
     * 小于则加1
     * 大于
     *
     * @param key
     * @param number
     * @param expire
     * @return
     */
    public boolean isLessAndIncreament(String key, int number, int expire) {
        if (this.compare(key, number).equals(Comparing.Small)) {
            this.increament(key, expire);
            return true;
        } else {
            return false;
        }
    }

    /**
     * @param key
     * @param number
     * @return
     */
    public Comparing compare(String key, int number) {
        int count = this.count(key);
        if (count == number) {
            return Comparing.Equal;
        } else if (count > number) {
            return Comparing.Big;
        } else {
            return Comparing.Small;
        }
    }

    public int count(String key) {
        String s = get(key);
        if (StringUtils.isBlank(s)) {
            return 0;
        } else {
            return Integer.parseInt(s);
        }
    }

    public void increament(String key, int expire) {
        BoundValueOperations<String, String> ops = redisTemplate.boundValueOps(key);
        ops.increment(1);
        ops.expire(expire, TimeUnit.SECONDS);
    }

    public void delete(String key) {
        redisTemplate.delete(key);
    }

    public String get(String key) {
        return redisTemplate.boundValueOps(key).get();
    }
}
