package com.chilunyc.fumao.common.util;

import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ConcurrentHashMap;
import java.util.function.BiConsumer;
import java.util.function.Function;
import java.util.function.Predicate;

/**
 *
 */
public class StreamHelper {

    /**
     * 按某个字段去重
     * @param keyExtractor
     * @param <T>
     * @return
     */
    public static <T> Predicate<T> distinctByKey(Function<? super T, ?> keyExtractor) {
        Map<Object, Boolean> seen = new ConcurrentHashMap<>();
        return t -> seen.putIfAbsent(keyExtractor.apply(t), Boolean.TRUE) == null;
    }

    /**
     *
     * @param els
     * @param action
     * @param <T>
     */
    public static <T> void foreach(Iterable<? extends T> els, BiConsumer<Integer, ? super T> action) {
        Objects.requireNonNull(els);
        Objects.requireNonNull(action);
        int index = 0;
        for (T el : els) {
            action.accept(index++, el);
        }
    }
}
