package com.chilunyc.fumao.common.util.http.config;

import okhttp3.ConnectionPool;
import okhttp3.OkHttpClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.concurrent.TimeUnit;

/**
 *
 */
@Configuration
@EnableConfigurationProperties(HttpProperty.class)
public class HttpConfig {

    @Autowired
    private HttpProperty sdkProperty;

    @Bean
    OkHttpClient okHttpClient() {
        return new OkHttpClient.Builder()
                .connectTimeout(10, TimeUnit.SECONDS) //
                .followRedirects(false) //
                .readTimeout(1, TimeUnit.MINUTES) //
                .retryOnConnectionFailure(false) //
                .writeTimeout(1, TimeUnit.MINUTES)
                .connectionPool(new ConnectionPool(sdkProperty.getHttpMaxConnect(), sdkProperty.getHttpKeepAlice(), TimeUnit.MINUTES)) //
                .build();
    }

}
