package com.chilunyc.fumao.common.util.http.service;

import com.chilunyc.fumao.common.util.http.service.result.ResultExecute;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StopWatch;

/**
 * 80347471@qq.com
 */
@Component
public class HttpClient {

    @Autowired
    private OkHttpClient client;

    public <T> T execute(HttpParams params, ResultExecute resultExecute) {
        Request request = params.toRequest();
        StopWatch stopWatch = new StopWatch();
        stopWatch.start();
        double consumeTime = 0;
        try {
            Response response = client.newCall(request).execute();
            stopWatch.stop();
            consumeTime = stopWatch.getTotalTimeSeconds();
            return (T) resultExecute.toBody(response, request, stopWatch);
        } catch (HttpException e) {
            throw e;
        } catch (Exception e) {
            throw HttpException.make(e, request, stopWatch);
        }
    }
}
