package com.chilunyc.fumao.company.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.*;
import org.hibernate.annotations.Parameter;
import org.hibernate.validator.constraints.*;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.ForeignKey;
import javax.validation.constraints.*;

import javax.persistence.*;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;
import java.lang.Long;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.Long;
import java.lang.String;
import java.lang.String;
import java.lang.Double;
import java.lang.Double;
import java.lang.Double;
import java.util.Date;

/**
 *
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@Entity
@Table(name = "fumao_place", indexes = {
        @Index(name = "market_companyId", columnList = "companyId"),
})
@EntityListeners(AuditingEntityListener.class)
public class Place implements Serializable {

    /**
     * 编号
     */
    @Id
    @Column(columnDefinition = "bigint(64)")
    @GeneratedValue(generator = "custom")
    @GenericGenerator(name = "custom", strategy = "com.chilunyc.fumao.common.util.jpa.CustomIdentifierGenerator", parameters = {@Parameter(name = "type", value = "Number")})
    private Long id;

    /**
     * 名称
     */
    @Column(columnDefinition = "varchar(64) comment '名称'")
    private String name;

    /**
     * 省份
     */
    @Column(columnDefinition = "varchar(10) comment '省份'")
    private String province;

    /**
     * 城市
     */
    @Column(columnDefinition = "varchar(10) comment '城市'")
    private String city;

    /**
     * 城市
     */
    @Column(columnDefinition = "varchar(10) comment '区域'")
    private String area;

    /**
     * POI
     */
    @Column(columnDefinition = "varchar(64) comment 'POI'")
    private String poi;

    /**
     * 经度
     */
    @Column(columnDefinition = "varchar(12) comment '经度'")
    private String lat;

    /**
     * 纬度
     */
    @Column(columnDefinition = "varchar(12) comment '纬度'")
    private String lng;

    /**
     * 地址
     */
    @Column(columnDefinition = "varchar(64) comment '地址'")
    private String address;

    /**
     * 集团
     */
    @Column(columnDefinition = "varchar(64) comment '集团'")
    private Long companyId;

    /**
     * 迈外迪
     */
    @Column(columnDefinition = "varchar(128) comment '迈外迪'")
    private String maiwaidiId;

    /**
     * ETCP
     */
    @Column(columnDefinition = "varchar(128) comment 'ETCP'")
    private String etcpId;

    /**
     * 总面积
     */
    @Column(columnDefinition = "decimal(9,2) comment '总面积'")
    private Double totalArea;

    /**
     * 营业面积
     */
    @Column(columnDefinition = "decimal(9,2) comment '营业面积'")
    private Double sellingArea;

    /**
     * 停车场面积
     */
    @Column(columnDefinition = "decimal(9,2) comment '停车场面积'")
    private Double depotArea;

    /**
     * 创建时间
     */
    @CreatedDate
    @Column(columnDefinition = "datetime comment '创建时间'")
    private Date createTime;


    @ManyToOne()
    @Fetch(FetchMode.JOIN)
    @JoinColumn(name = "companyId", insertable = false, updatable = false, foreignKey = @ForeignKey(name = "none", value = ConstraintMode.NO_CONSTRAINT))
    @NotFound(action=NotFoundAction.IGNORE)
    private Company company;
}
