package com.chilunyc.fumao.company.model;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.*;
import org.hibernate.annotations.Parameter;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import org.springframework.data.jpa.domain.support.AuditingEntityListener;
import org.springframework.data.annotation.CreatedDate;

import javax.persistence.*;
import javax.persistence.Entity;
import javax.persistence.Index;
import javax.persistence.Table;
import java.io.Serializable;
import java.util.Date;
import java.lang.Long;
import java.lang.String;
import java.lang.String;
import java.lang.String;
import java.lang.String;

/**
 *
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@Entity
@Table(name = "fumao_shop_apply", indexes = {
})
@EntityListeners(AuditingEntityListener.class)
public class ShopApply implements Serializable {

    /**
     * 编号
     */
    @Id
    @Column(columnDefinition = "bigint(64)")
    @GeneratedValue(generator = "custom")
    @GenericGenerator(name = "custom", strategy = "com.chilunyc.fumao.common.util.jpa.CustomIdentifierGenerator", parameters = {@Parameter(name = "type", value = "Number")})
    private Long id;

    /**
     * 商铺名称
     */
    @Column(columnDefinition = "varchar(64) comment '商铺名称'")
    private String name;

    /**
     * 申请人
     */
    @Column(columnDefinition = "varchar(64) comment '申请人'")
    private String proposer;

    /**
     * 手机号
     */
    @Column(columnDefinition = "varchar(20) comment '手机号'")
    private String mobile;

    /**
     * 备注
     */
    @Column(columnDefinition = "text comment '备注'")
    private String market;

    /**
     * 创建时间
     */
    @CreatedDate
    @Column(columnDefinition = "datetime comment '创建时间'")
    private Date createTime;
}
