package com.chilunyc.fumao.company.request.company;

import com.chilunyc.fumao.company.request.place.PlaceEditRequest;
import com.chilunyc.fumao.company.request.placeAdmin.PlaceAdminEditRequest;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import java.lang.String;
import java.util.List;

/**
 *
 */
@ApiModel
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class CompanyEditRequest {

    private Long id;

    @NotBlank(message = "请输入名称")
    @ApiModelProperty(value = "名称")
    private String name;

    @NotNull(message = "请输入省市区")
    @Size(min = 3, message = "请选择省市区")
    @ApiModelProperty(value = "省份")
    private String[] region;

    @NotBlank(message = "请输入POI")
    @ApiModelProperty(value = "POI")
    private String poi;

    @NotBlank(message = "请输入经度")
    @ApiModelProperty(value = "经度")
    private String lat;

    @NotBlank(message = "请输入纬度")
    @ApiModelProperty(value = "纬度")
    private String lng;

    @NotBlank(message = "请输入地址")
    @ApiModelProperty(value = "地址")
    private String address;
}
