package com.chilunyc.fumao.company.request.place;

import com.chilunyc.fumao.company.request.placeAdmin.PlaceAdminEditRequest;
import com.chilunyc.fumao.company.request.placeFloor.PlaceFloorEditRequest;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.validator.constraints.NotBlank;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

/**
 *
 */
@ApiModel
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class PlaceEditRequest {

    private Long id;

    @NotBlank(message = "请输入名称")
    @ApiModelProperty(value = "名称")
    private String name;

    @NotNull(message = "请输入省市区")
    @Size(min = 3, message = "请选择省市区")
    @ApiModelProperty(value = "省份")
    private String[] region;

    @NotBlank(message = "请输入POI")
    @ApiModelProperty(value = "POI")
    private String poi;

    @NotBlank(message = "请输入经度")
    @ApiModelProperty(value = "经度")
    private String lat;

    @NotBlank(message = "请输入纬度")
    @ApiModelProperty(value = "纬度")
    private String lng;

    @NotBlank(message = "请输入地址")
    @ApiModelProperty(value = "地址")
    private String address;

    @NotNull(message = "请输入集团")
    @ApiModelProperty(value = "集团")
    private Long companyId;

    @ApiModelProperty(value = "迈外迪")
    private String maiwaidId;

    @ApiModelProperty(value = "ETCP")
    private String etcpId;

    @ApiModelProperty(value = "总面积")
    private Double totalArea;

    @ApiModelProperty(value = "营业面积")
    private Double sellingArea;

    @ApiModelProperty(value = "停车场面积")
    private Double depotArea;

    private List<PlaceFloorEditRequest> placeFloorList;

    private List<PlaceAdminEditRequest> placeAdminList;
}
