package com.chilunyc.fumao.company.request.placeAdmin;

import com.chilunyc.fumao.company.model.enums.PlaceAdminType;
import org.hibernate.validator.constraints.*;

import javax.validation.constraints.*;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;

import java.lang.Long;
import java.lang.String;

/**
 *
 */
@ApiModel
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
public class PlaceAdminEditRequest {

    private Long id;

    @NotBlank(message = "请输入名称")
    @ApiModelProperty(value = "名称")
    private String name;

    @NotBlank(message = "请输入密码")
    @Pattern(regexp = "[\\w\\d]{6,18}", message = "长度6-18位的字母数字")
    @ApiModelProperty(value = "密码")
    private String password;

    @Pattern(regexp = "1[\\d]{10}", message = "请输入11位手机号")
    @ApiModelProperty(value = "手机号")
    private String mobile;

    @ApiModelProperty(value = "集团")
    private Long companyId;

    @NotNull(message = "请选择商场")
    @ApiModelProperty(value = "集团商场")
    private Long placeId;

    private PlaceAdminType placeAdminType;

}
